
*********Bootstrap 1, code build based on Cameron and Miller (2008)
**************Bootstrap, not sure about source
/*
capture net install estout, from(http://fmwww.bc.edu/RePEc/bocode/e)		/* checks whether estout is installed		*/
capture net install spmon, from(http://fmwww.bc.edu/RePEc/bocode/s)			/* checks whether spmon is installed		*/
*/
set more off
 
 **********************************************************************************************************
 ***************************Main Program Wild cluster bootstrap with Null imposed treatment = 0************
 **********************************************************************************************************
 
 cap program drop  boot
 	  program boot, rclass
		    syntax varlist [if] [in] ,unit(string) [bots(integer 50)]          //Use different names than existing Stata ones
local depend =word("`varlist'",1)
local interest=word("`varlist'",2)
local ivs1:list  varlist - depend
local ivs: list ivs1- interest
 * cap  drop uR xbR
  *args  depend interest  cluster  No(integer 50)
 *and the null hypothesis H0: _b[CrimWinner] = 0.0
 * Step 1: *
*Step 1-1) Compute w (if my t_0 was 0, it would be the t from the table).
 quietly ivreg2 `depend' `interest' `ivs' , cluster(`unit')
 global w = (_b[`interest'] - .0)/ _se[`interest']
 di "$w'"
  *Step 1-2: fit the restrained constraint. Regress Y on all X except the one we want to test 
  constraint 1 `interest' = .0  //This sets the constraint, Treat=0, Null imposed
  quietly cnsreg `depend' `interest' `ivs' , constraint(1) cluster(`unit')
  mat bR = e(b)
  quietly predict uR , residuals
  quietly predict xbR, xb
   *There is one long vector of residuals uR,  *There also is the restricted linear prediction xbR
   
 ***************************************************************************************************
 simulate  wstar = r(wstar) b=r(b) se=r(se) W_webb=r(wstar_Webb) b_Webb=r(b_Webb) se_Webb=r(se_Webb) ///
 , reps(`bots') saving(wstar_file, replace): getwstar `depend' `interest' `ivs',unit("`unit'") //Acess the getwstar program defined above
 use wstar_file, clear
 gen Test=0
 *Wstar refers to the vector of pvalues from the bootstrap, using the 2-point distribution. $w is the T-stat from the original regression.
 *Then check which share of the bootstraped T-stats is larger than the original one to get p-value
 replace Test = 1 if abs(wstar)>abs($w)  // If Rademache-based T-stat is larger than tHat from main regression, some might be smaller and some larger. 
 egen Wl=sum(Test)  //Sum up to get the number of bootstrap repetitions for which the tstat indicates significance.
  *Rademacher weights
 scalar Pvalue_Rad=2*Wl/_N  //Two sided test, taking the smaller value of W1 and Ws for absolute values
 *Webb weights, bootstraped y values are different.
 drop Test Wl 
  gen Test=0
 replace Test = 1 if abs(W_webb)>abs($w)  //Smaller than tHat from main regression
 egen Wl=sum(Test)
 scalar Pvalue_Webb=2*Wl/_N         //_N are all the bootstrap repetitions, in what share of those is the T-stat larger than the original one,  This yields the symmetric bootstrap p-value
 * See http://www.maxwell.syr.edu/uploadedFiles/cpr/events/cpr_camp_econometrics/papers2013/MacKinnon_Webb.pdf page. 8 

 return scalar Pvalue_Rad =Pvalue_Rad
 return scalar Pvalue_Webb =Pvalue_Webb
use "data_final_extended.dta", clear
 *restore,preserve
 end
 ***************************************************************************************************
 *********************Program, compare Webb 2014*****************************************************
 *************************************************************************************************** 
 cap program drop  getwstar
  program getwstar, rclass
	    syntax varlist [if] [in] ,unit(string)
		local depend =word("`varlist'",1)
local interest=word("`varlist'",2)
local ivs1:list  varlist - depend
local ivs: list ivs1- interest
	display `interest'
	display `ivs'
	   *I am using external variables rep, uR, xbR, disp and turn 
   tempvar ag uRstar yhatstar Webb uRstar_Webb yhatstar_Webb my_uniform
   *Use the rademacher 2-point distribution to simulate Ustar and create new YHats.
   sort `unit' 
   gen `ag' = cond(runiform()<.5, -1, 1) // * Step 2a: * *Form a sample of clusters. Step 2a-1: generate the weights a_g, which are unique to each
   bysort `unit': replace `ag' = `ag'[1]
   gen `uRstar' = uR*`ag'  //  *setp 2a-2: generate uRstar
   gen `yhatstar' = xbR + `uRstar'  //  *step 2a-3: generate yhatstar
   quietly reg  `yhatstar' `interest' `ivs', cluster(`unit')
   return scalar wstar = (_b[`interest'] - .0)/ _se[`interest']
   return scalar b=_b[`interest']
   return scalar se=_se[`interest']
   /*Calculate the Wald test statistic w*b its standard error sȬb are obtained from unrestricted
OLS estimation using the bth pseudo-sample, with s(߱,b) computed
using the same method as that in step 1.  From Cameron and Miller 2008 page 427*/     
   *Use the Webb 6-point distribution to simulate Ustar and create new YHats.
   sort `unit' 
gen `my_uniform' = uniform()  
gen `Webb' = 	(-1) * sqrt(1.5) * (`my_uniform' > (0) & `my_uniform' <= (1/6)) +  ///
						(-1) * sqrt(1) * (`my_uniform' > (1/6) & `my_uniform' <= (2/6))  + ///
						(-1) * sqrt(0.5) * (`my_uniform' > (2/6) & `my_uniform' <= (3/6)) + ///
						(+1) * sqrt(0.5) * (`my_uniform' > (3/6) & `my_uniform' <= (4/6)) + ///
						(+1) * sqrt(1) * (`my_uniform' > (4/6) & `my_uniform' <= (5/6))  + ///
						(+1) * sqrt(1.5) * (`my_uniform' > (5/6) & `my_uniform' <= (6/6)) 
   bysort `unit': replace `Webb' = `Webb'[1]
   gen `uRstar_Webb' = uR*`Webb'
   gen `yhatstar_Webb' = xbR + `uRstar_Webb'
   quietly ivreg2  `yhatstar_Webb' `interest' `ivs', cluster(`unit')
   return scalar wstar_Webb = (_b[`interest'] - .0)/ _se[`interest']
   return scalar b_Webb=_b[`interest']
   return scalar se_Webb=_se[`interest']
 end

 

 
 
 
 
 
 
 
 ***************************************************************
 ******************Null not imposed****************************
 ***************************************************************
cap program drop  boot_nonull
 	  program boot_nonull, rclass
*This part runs the restricted or unrestricted regression, and predicts residuals for the bootstrap
syntax varlist [if] [in] ,unit(string) [bots(integer 50)]          //Use different names than existing Stata ones
local depend =word("`varlist'",1)
local interest=word("`varlist'",2)
local ivs1:list  varlist - depend
local ivs: list ivs1- interest
 * cap  drop uR xbR
  *args  depend interest  cluster  No(integer 50)
 *and the null hypothesis H0: _b[Interest] = 0.0
 
 * Step 1: * Calculat the orginal T-stat and save it
*Step 1-1) Compute w (if my t_0 was 0, it would be the t from the table).
 quietly ivreg2 `depend' `interest' `ivs' , cluster(`unit')
 global binterst= _b[`interest']
 global w = (_b[`interest'] - 0)/ _se[`interest']
 di "$w'"
 
  *Step 1-2 fit the unrestrained equation. Regress Y on all X except the one we want to test 
  quietly ivreg2 `depend' `interest' `ivs' ,  cluster(`unit')
  mat bR = e(b)
  quietly predict uR , residuals
  quietly predict xbR, xb
   *There is one long vector of residuals uR,  *There also is the restricted linear prediction xbR
   
 simulate  wstar = r(wstar) b=r(b) se=r(se) W_webb=r(wstar_Webb) b_Webb=r(b_Webb) se_Webb=r(se_Webb) ///
 , reps(`bots') saving(wstar_file_nonull, replace): getwstarUR `depend' `interest' `ivs',unit("`unit'")  //Acess the program defined below
 
 *************************Use generated file with bootstrap results*****************************
 use wstar_file_nonull, clear
 gen Test=0
 *Wstar refers to the vector of pvalues from the bootstrap, using the 2-point distribution. $w is the T-stat from the original regression.
 *Then check which share of the bootstraped T-stats is larger than the original one to get p-value
 replace Test = 1 if abs(wstar)>abs($w)  // If Rademache-based T-stat is larger than tHat from main regression, some might be smaller and some larger. 
 egen Wl=sum(Test)  //Sum up to get the number of bootstrap repetitions for which the tstat indicates significance.
  *Rademacher weights
 scalar Pvalue_Rad_nonull=2*Wl/_N  //Two sided test, taking the smaller value of W1 and Ws for absolute values
 
 *Webb weights, bootstraped y values are different.
 drop Test Wl 
  gen Test=0
 replace Test = 1 if abs(W_webb)>abs($w)  //Smaller than tHat from main regression
 egen Wl=sum(Test)
  scalar Pvalue_Webb_nonull=2*Wl/_N         //_N are all the bootstrap repetitions, in what share of those is the T-stat larger than the original one, 2* due to twosided test

 return scalar Pvalue_Rad_nonull =Pvalue_Rad_nonull
 return scalar Pvalue_Webb_nonull  =Pvalue_Webb_nonull
 use "data_final_extended.dta", clear
 *restore,preserve
 end
  **************************************************************************************************** 
 *******************This runs the test in each bootstrap sample*************************************
 *************************************************************************************************** 
 cap program drop  getwstarUR
  program getwstarUR, rclass
	    syntax varlist [if] [in] ,unit(string)
		local depend =word("`varlist'",1)
local interest=word("`varlist'",2)
local ivs1:list  varlist - depend
local ivs: list ivs1- interest
	display `interest'
	display `ivs'
	   *I am using external variables rep, uR, xbR, disp and turn 
   tempvar ag uRstar yhatstar Webb uRstar_Webb yhatstar_Webb my_uniform
   *Use the rademacher 2-point distribution to simulate Ustar and create new YHats.
   sort `unit' 
   gen `ag' = cond(runiform()<.5, -1, 1) // * Step 2a: * *Form a sample of clusters. Step 2a-1: generate the weights a_g, which are unique to each
   bysort `unit': replace `ag' = `ag'[1]
   gen `uRstar' = uR*`ag'  //  *setp 2a-2: generate uRstar
   gen `yhatstar' = xbR + `uRstar'  //  *step 2a-3: generate yhatstar
   quietly regress  `yhatstar' `interest' `ivs', cluster(`unit')
   return scalar wstar = (_b[`interest'] - $binterst)/ _se[`interest']
   return scalar b=_b[`interest']
   return scalar se=_se[`interest']
   /*Calculate the Wald test statistic w*b its standard error sȬb are obtained from unrestricted
OLS estimation using the bth pseudo-sample, with s(߱,b) computed
using the same method as that in step 1.  From Cameron and Miller 2008 page 427*/     
   *Use the Webb 6-point distribution to simulate Ustar and create new YHats.
   sort `unit' 
gen `my_uniform' = uniform()  
gen `Webb' = 	(-1) * sqrt(1.5) * (`my_uniform' > (0) & `my_uniform' <= (1/6)) +  ///
						(-1) * sqrt(1) * (`my_uniform' > (1/6) & `my_uniform' <= (2/6))  + ///
						(-1) * sqrt(0.5) * (`my_uniform' > (2/6) & `my_uniform' <= (3/6)) + ///
						(+1) * sqrt(0.5) * (`my_uniform' > (3/6) & `my_uniform' <= (4/6)) + ///
						(+1) * sqrt(1) * (`my_uniform' > (4/6) & `my_uniform' <= (5/6))  + ///
						(+1) * sqrt(1.5) * (`my_uniform' > (5/6) & `my_uniform' <= (6/6)) 
   bysort `unit': replace `Webb' = `Webb'[1]
   gen `uRstar_Webb' = uR*`Webb'
   gen `yhatstar_Webb' = xbR + `uRstar_Webb'
   quietly ivreg2  `yhatstar_Webb' `interest' `ivs', cluster(`unit')
   return scalar wstar_Webb = (_b[`interest'] - $binterst)/ _se[`interest']
   return scalar b_Webb=_b[`interest']
   return scalar se_Webb=_se[`interest']
 end

 
 
 
 
 
 
 
